diff -crN ../src.orig/backend/postmaster/postmaster.c ./backend/postmaster/postmaster.c
*** ../src.orig/backend/postmaster/postmaster.c	Sat Jun  2 11:17:49 2001
--- ./backend/postmaster/postmaster.c	Sat Jun  2 11:18:33 2001
***************
*** 96,101 ****
--- 96,103 ----
  #include "utils/memutils.h"
  #include "bootstrap/bootstrap.h"
  
+ #include "pgstat.h"
+ 
  #define INVALID_SOCK	(-1)
  #define ARGV_SIZE	64
  
***************
*** 560,565 ****
--- 562,575 ----
  		ExitPostmaster(1);
  	}
  
+ 	/*
+ 	 * Initialize and startup the statistics collector process
+ 	 */
+ 	if (pgstat_init() < 0)
+ 		ExitPostmaster(1);
+ 	if (pgstat_start() < 0)
+ 		ExitPostmaster(1);
+ 
  	if (DebugLvl > 2)
  	{
  		extern char **environ;
***************
*** 1586,1591 ****
--- 1596,1613 ----
  	{
  		exitstatus = status.w_status;
  #endif
+ 		/*
+ 		 * Check if this child was the statistics collector. If
+ 		 * so, start a new one. 
+ 		 */
+ 		if (pgstat_ispgstat(pid))
+ 		{
+ 			fprintf(stderr, "%s: Performance collector exited with status %d\n",
+ 					progname, exitstatus);
+ 			pgstat_start();
+ 			continue;
+ 		}
+ 
  		if (ShutdownPID > 0)
  		{
  			if (pid != ShutdownPID)
***************
*** 1633,1638 ****
--- 1655,1661 ----
  			errno = save_errno;
  			return;
  		}
+ 
  		CleanupProc(pid, exitstatus);
  	}
  
***************
*** 1736,1741 ****
--- 1759,1769 ----
  			/* Why is this done here, and not by the backend itself? */
  			if (!FatalError)
  				ProcRemove(pid);
+ 
+ 			/*
+ 			 * Tell the collector about backend termination
+ 			 */
+ 			pgstat_beterm(pid);
  		}
  
  		return;
***************
*** 1799,1804 ****
--- 1827,1839 ----
  	{
  		CheckPointPID = 0;
  		checkpointed = 0;
+ 	}
+ 	else
+ 	{
+ 		/*
+ 		 * Tell the collector about backend termination
+ 		 */
+ 		pgstat_beterm(pid);
  	}
  
  	FatalError = true;
diff -crN ../src.orig/backend/storage/buffer/bufmgr.c ./backend/storage/buffer/bufmgr.c
*** ../src.orig/backend/storage/buffer/bufmgr.c	Sat Jun  2 11:17:49 2001
--- ./backend/storage/buffer/bufmgr.c	Sat Jun  2 11:18:33 2001
***************
*** 55,60 ****
--- 55,62 ----
  #include "utils/relcache.h"
  #include "catalog/pg_database.h"
  
+ #include "pgstat.h"
+ 
  #define BufferGetLSN(bufHdr)	\
  	(*((XLogRecPtr*)MAKE_PTR((bufHdr)->data)))
  
***************
*** 183,188 ****
--- 185,191 ----
  	if (isLocalBuf)
  	{
  		ReadLocalBufferCount++;
+ 		pgstat_count_buffer_read(&reln->pgstat_info, reln);
  		/* Substitute proper block number if caller asked for P_NEW */
  		if (blockNum == P_NEW)
  		{
***************
*** 192,202 ****
--- 195,209 ----
  		}
  		bufHdr = LocalBufferAlloc(reln, blockNum, &found);
  		if (found)
+ 		{
  			LocalBufferHitCount++;
+ 			pgstat_count_buffer_hit(&reln->pgstat_info, reln);
+ 		}
  	}
  	else
  	{
  		ReadBufferCount++;
+ 		pgstat_count_buffer_read(&reln->pgstat_info, reln);
  		/* Substitute proper block number if caller asked for P_NEW */
  		if (blockNum == P_NEW)
  		{
***************
*** 211,217 ****
--- 218,227 ----
  			SpinAcquire(BufMgrLock);
  		bufHdr = BufferAlloc(reln, blockNum, &found);
  		if (found)
+ 		{
  			BufferHitCount++;
+ 			pgstat_count_buffer_hit(&reln->pgstat_info, reln);
+ 		}
  	}
  
  	/* At this point we do NOT hold the bufmgr spinlock. */
diff -crN ../src.orig/backend/storage/large_object/inv_api.c ./backend/storage/large_object/inv_api.c
*** ../src.orig/backend/storage/large_object/inv_api.c	Sat Jun  2 11:17:49 2001
--- ./backend/storage/large_object/inv_api.c	Sat Jun  2 11:18:33 2001
***************
*** 227,233 ****
  	while ((indexRes = index_getnext(sd, BackwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(obj_desc->heap_r, SnapshotNow, &tuple, &buffer);
  		pfree(indexRes);
  		if (tuple.t_data == NULL)
  			continue;
--- 227,233 ----
  	while ((indexRes = index_getnext(sd, BackwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(obj_desc->heap_r, SnapshotNow, &tuple, &buffer, sd);
  		pfree(indexRes);
  		if (tuple.t_data == NULL)
  			continue;
***************
*** 339,345 ****
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(obj_desc->heap_r, SnapshotNow, &tuple, &buffer);
  		pfree(indexRes);
  
  		if (tuple.t_data == NULL)
--- 339,345 ----
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(obj_desc->heap_r, SnapshotNow, &tuple, &buffer, sd);
  		pfree(indexRes);
  
  		if (tuple.t_data == NULL)
***************
*** 473,479 ****
  			while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  			{
  				oldtuple.t_self = indexRes->heap_iptr;
! 				heap_fetch(obj_desc->heap_r, SnapshotNow, &oldtuple, &buffer);
  				pfree(indexRes);
  				if (oldtuple.t_data != NULL)
  				{
--- 473,479 ----
  			while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  			{
  				oldtuple.t_self = indexRes->heap_iptr;
! 				heap_fetch(obj_desc->heap_r, SnapshotNow, &oldtuple, &buffer, sd);
  				pfree(indexRes);
  				if (oldtuple.t_data != NULL)
  				{
diff -crN ../src.orig/backend/tcop/postgres.c ./backend/tcop/postgres.c
*** ../src.orig/backend/tcop/postgres.c	Sat Jun  2 11:17:49 2001
--- ./backend/tcop/postgres.c	Sat Jun  2 11:18:33 2001
***************
*** 65,70 ****
--- 65,71 ----
  #include "mb/pg_wchar.h"
  #endif
  
+ #include "pgstat.h"
  
  /* ----------------
   *		global variables
***************
*** 1726,1731 ****
--- 1727,1739 ----
  										 ALLOCSET_DEFAULT_INITSIZE,
  										 ALLOCSET_DEFAULT_MAXSIZE);
  
+ 	/* ----------
+ 	 * Tell the statistics collector that we're alive and
+ 	 * to which database we belong.
+ 	 * ----------
+ 	 */
+ 	pgstat_bestart();
+ 
  	/*
  	 * POSTGRES main processing loop begins here
  	 *
***************
*** 1811,1820 ****
--- 1819,1841 ----
  		 */
  		ReadyForQuery(whereToSendOutput);
  
+ 		/* ----------
+ 		 * Tell the statistics collector what we've collected
+ 		 * so far.
+ 		 * ----------
+ 		 */
+ 		pgstat_report_tabstat();
+ 
  		if (IsTransactionBlock())
+ 		{
  			set_ps_display("idle in transaction");
+ 			pgstat_report_activity("<IDLE> in transaction");
+ 		}
  		else
+ 		{
  			set_ps_display("idle");
+ 			pgstat_report_activity("<IDLE>");
+ 		}
  
  		/*
  		 * (2) deal with pending asynchronous NOTIFY from other backends,
***************
*** 1865,1870 ****
--- 1886,1897 ----
  				 * 'F' indicates a fastpath call.
  				 */
  			case 'F':
+ 				/* ----------
+ 				 * Tell the collector what we're doing
+ 				 * ----------
+ 				 */
+ 				pgstat_report_activity("<FASTPATH> function call");
+ 
  				/* start an xact for this function invocation */
  				start_xact_command();
  
***************
*** 1904,1909 ****
--- 1931,1938 ----
  					 */
  					if (Show_query_stats)
  						ResetUsage();
+ 
+ 					pgstat_report_activity(parser_input->data);
  
  					pg_exec_query_string(parser_input->data,
  										 whereToSendOutput,
diff -crN ../src.orig/backend/utils/adt/Makefile ./backend/utils/adt/Makefile
*** ../src.orig/backend/utils/adt/Makefile	Sat Jun  2 11:17:49 2001
--- ./backend/utils/adt/Makefile	Sat Jun  2 11:18:33 2001
***************
*** 24,30 ****
  	tid.o timestamp.o varbit.o varchar.o varlena.o version.o \
  	network.o mac.o inet_net_ntop.o inet_net_pton.o \
  	ri_triggers.o pg_lzcompress.o pg_locale.o formatting.o \
! 	ascii.o quote.o
  
  all: SUBSYS.o
  
--- 24,30 ----
  	tid.o timestamp.o varbit.o varchar.o varlena.o version.o \
  	network.o mac.o inet_net_ntop.o inet_net_pton.o \
  	ri_triggers.o pg_lzcompress.o pg_locale.o formatting.o \
! 	ascii.o quote.o pgstatfuncs.o
  
  all: SUBSYS.o
  
diff -crN ../src.orig/backend/utils/adt/pgstatfuncs.c ./backend/utils/adt/pgstatfuncs.c
*** ../src.orig/backend/utils/adt/pgstatfuncs.c	Wed Dec 31 19:00:00 1969
--- ./backend/utils/adt/pgstatfuncs.c	Sat Jun  2 11:18:33 2001
***************
*** 0 ****
--- 1,399 ----
+ #include "postgres.h"
+ #include "fmgr.h"
+ 
+ #include "utils/hsearch.h"
+ #include "access/xact.h"
+ #include "catalog/pg_shadow.h"
+ #include "nodes/execnodes.h"
+ 
+ #include "pgstat.h"
+ 
+ extern Datum	pg_stat_get_numscans(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_tuples_returned(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_tuples_fetched(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_tuples_inserted(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_tuples_updated(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_tuples_deleted(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_blocks_fetched(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_blocks_hit(PG_FUNCTION_ARGS);
+ 
+ extern Datum	pg_stat_get_backend_idset(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_backend_pid(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_backend_dbid(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_backend_userid(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_backend_activity(PG_FUNCTION_ARGS);
+ 
+ extern Datum	pg_stat_get_db_numbackends(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_db_xact_commit(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_db_xact_rollback(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_db_blocks_fetched(PG_FUNCTION_ARGS);
+ extern Datum	pg_stat_get_db_blocks_hit(PG_FUNCTION_ARGS);
+ 
+ 
+ 
+ PG_FUNCTION_INFO_V1(pg_stat_get_numscans);
+ PG_FUNCTION_INFO_V1(pg_stat_get_tuples_returned);
+ PG_FUNCTION_INFO_V1(pg_stat_get_tuples_fetched);
+ PG_FUNCTION_INFO_V1(pg_stat_get_tuples_inserted);
+ PG_FUNCTION_INFO_V1(pg_stat_get_tuples_updated);
+ PG_FUNCTION_INFO_V1(pg_stat_get_tuples_deleted);
+ PG_FUNCTION_INFO_V1(pg_stat_get_blocks_fetched);
+ PG_FUNCTION_INFO_V1(pg_stat_get_blocks_hit);
+ 
+ PG_FUNCTION_INFO_V1(pg_stat_get_backend_idset);
+ PG_FUNCTION_INFO_V1(pg_stat_get_backend_pid);
+ PG_FUNCTION_INFO_V1(pg_stat_get_backend_dbid);
+ PG_FUNCTION_INFO_V1(pg_stat_get_backend_userid);
+ PG_FUNCTION_INFO_V1(pg_stat_get_backend_activity);
+ 
+ PG_FUNCTION_INFO_V1(pg_stat_get_db_numbackends);
+ PG_FUNCTION_INFO_V1(pg_stat_get_db_xact_commit);
+ PG_FUNCTION_INFO_V1(pg_stat_get_db_xact_rollback);
+ PG_FUNCTION_INFO_V1(pg_stat_get_db_blocks_fetched);
+ PG_FUNCTION_INFO_V1(pg_stat_get_db_blocks_hit);
+ 
+ 
+ Datum
+ pg_stat_get_numscans(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->numscans);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_tuples_returned(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->tuples_returned);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_tuples_fetched(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->tuples_fetched);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_tuples_inserted(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->tuples_inserted);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_tuples_updated(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->tuples_updated);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_tuples_deleted(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->tuples_deleted);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_blocks_fetched(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->blocks_fetched);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_blocks_hit(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatTabEntry	   *tabentry;
+ 	Oid						relid;
+ 	int64					result;
+ 
+ 	relid  = PG_GETARG_OID(0);
+ 
+ 	if ((tabentry = pgstat_fetch_stat_tabentry(relid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(tabentry->blocks_hit);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_backend_idset(PG_FUNCTION_ARGS)
+ {
+ 	FmgrInfo	   *fmgr_info = fcinfo->flinfo;
+ 	MemoryContext	oldcxt;
+ 	int32			result;
+ 
+ 	if (fcinfo->resultinfo == NULL)
+ 		elog(ERROR, "called in context that does not accept a set result (1)");
+ 	if (!IsA(fcinfo->resultinfo, ReturnSetInfo))
+ 		elog(ERROR, "called in context that does not accept a set result (2)");
+ 
+ 	if (fmgr_info->fn_extra == NULL)
+ 	{
+ 		if (fmgr_info->fn_mcxt == NULL)
+ 			elog(ERROR, "No function memory context in set-function");
+ 
+ 		oldcxt = MemoryContextSwitchTo(fmgr_info->fn_mcxt);
+ 		fmgr_info->fn_extra = palloc(sizeof(int32) * 2);
+ 		((int32 *)(fmgr_info->fn_extra))[0] = 0;
+ 		((int32 *)(fmgr_info->fn_extra))[1] = 
+ 						(int32)pgstat_fetch_stat_numbackends();
+ 		MemoryContextSwitchTo(oldcxt);
+ 	}
+ 
+ 	((int32 *)(fmgr_info->fn_extra))[0] += 1;
+ 	result = ((int32 *)(fmgr_info->fn_extra))[0];
+ 
+ 
+ 	if (result > ((int32 *)(fmgr_info->fn_extra))[1])
+ 	{
+ 		((ReturnSetInfo *)(fcinfo->resultinfo))->isDone = ExprEndResult;
+ 		PG_RETURN_NULL();
+ 	}
+ 
+ 	((ReturnSetInfo *)(fcinfo->resultinfo))->isDone = ExprMultipleResult;
+ 	PG_RETURN_INT32(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_backend_pid(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatBeEntry	   *beentry;
+ 	int32					beid;
+ 
+ 	beid  = PG_GETARG_INT32(0);
+ 
+ 	if ((beentry = pgstat_fetch_stat_beentry(beid)) == NULL)
+ 		PG_RETURN_NULL();
+ 
+ 	PG_RETURN_INT32(beentry->procpid);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_backend_dbid(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatBeEntry	   *beentry;
+ 	int32					beid;
+ 
+ 	beid  = PG_GETARG_INT32(0);
+ 
+ 	if ((beentry = pgstat_fetch_stat_beentry(beid)) == NULL)
+ 		PG_RETURN_NULL();
+ 
+ 	PG_RETURN_OID(beentry->databaseid);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_backend_userid(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatBeEntry	   *beentry;
+ 	int32					beid;
+ 
+ 	beid  = PG_GETARG_INT32(0);
+ 
+ 	if ((beentry = pgstat_fetch_stat_beentry(beid)) == NULL)
+ 		PG_RETURN_NULL();
+ 
+ 	PG_RETURN_OID(beentry->userid);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_backend_activity(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatBeEntry	   *beentry;
+ 	int32					beid;
+ 	int						len;
+ 	text				   *result;
+ 
+ 	if (!superuser())
+ 		PG_RETURN_NULL();
+ 
+ 	beid  = PG_GETARG_INT32(0);
+ 
+ 	if ((beentry = pgstat_fetch_stat_beentry(beid)) == NULL)
+ 		PG_RETURN_NULL();
+ 
+ 	len = strlen(beentry->activity);
+ 	result = palloc(VARHDRSZ + len);
+ 	VARATT_SIZEP(result) = VARHDRSZ + len;
+ 	memcpy(VARDATA(result), beentry->activity, len);
+ 
+ 	PG_RETURN_TEXT_P(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_db_numbackends(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatDBEntry	   *dbentry;
+ 	Oid						dbid;
+ 	int32					result;
+ 
+ 	dbid  = PG_GETARG_OID(0);
+ 
+ 	if ((dbentry = pgstat_fetch_stat_dbentry(dbid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int32)(dbentry->n_backends);
+ 
+ 	PG_RETURN_INT32(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_db_xact_commit(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatDBEntry	   *dbentry;
+ 	Oid						dbid;
+ 	int64					result;
+ 
+ 	dbid  = PG_GETARG_OID(0);
+ 
+ 	if ((dbentry = pgstat_fetch_stat_dbentry(dbid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(dbentry->n_xact_commit);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_db_xact_rollback(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatDBEntry	   *dbentry;
+ 	Oid						dbid;
+ 	int64					result;
+ 
+ 	dbid  = PG_GETARG_OID(0);
+ 
+ 	if ((dbentry = pgstat_fetch_stat_dbentry(dbid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(dbentry->n_xact_rollback);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_db_blocks_fetched(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatDBEntry	   *dbentry;
+ 	Oid						dbid;
+ 	int64					result;
+ 
+ 	dbid  = PG_GETARG_OID(0);
+ 
+ 	if ((dbentry = pgstat_fetch_stat_dbentry(dbid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(dbentry->n_blocks_fetched);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
+ Datum
+ pg_stat_get_db_blocks_hit(PG_FUNCTION_ARGS)
+ {
+ 	PgStat_StatDBEntry	   *dbentry;
+ 	Oid						dbid;
+ 	int64					result;
+ 
+ 	dbid  = PG_GETARG_OID(0);
+ 
+ 	if ((dbentry = pgstat_fetch_stat_dbentry(dbid)) == NULL)
+ 		result = 0;
+ 	else
+ 		result = (int64)(dbentry->n_blocks_hit);
+ 
+ 	PG_RETURN_INT64(result);
+ }
+ 
+ 
diff -crN ../src.orig/backend/utils/adt/regproc.c ./backend/utils/adt/regproc.c
*** ../src.orig/backend/utils/adt/regproc.c	Sat Jun  2 11:17:49 2001
--- ./backend/utils/adt/regproc.c	Sat Jun  2 11:18:33 2001
***************
*** 90,96 ****
  				tuple.t_self = indexRes->heap_iptr;
  				heap_fetch(hdesc, SnapshotNow,
  						   &tuple,
! 						   &buffer);
  				pfree(indexRes);
  				if (tuple.t_data != NULL)
  				{
--- 90,97 ----
  				tuple.t_self = indexRes->heap_iptr;
  				heap_fetch(hdesc, SnapshotNow,
  						   &tuple,
! 						   &buffer,
! 						   sd);
  				pfree(indexRes);
  				if (tuple.t_data != NULL)
  				{
diff -crN ../src.orig/backend/utils/cache/catcache.c ./backend/utils/cache/catcache.c
*** ../src.orig/backend/utils/cache/catcache.c	Sat Jun  2 11:17:49 2001
--- ./backend/utils/cache/catcache.c	Sat Jun  2 11:18:33 2001
***************
*** 915,921 ****
  		while ((indexRes = index_getnext(isd, ForwardScanDirection)))
  		{
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(relation, SnapshotNow, &tuple, &buffer);
  			pfree(indexRes);
  			if (tuple.t_data != NULL)
  			{
--- 915,921 ----
  		while ((indexRes = index_getnext(isd, ForwardScanDirection)))
  		{
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(relation, SnapshotNow, &tuple, &buffer, isd);
  			pfree(indexRes);
  			if (tuple.t_data != NULL)
  			{
diff -crN ../src.orig/backend/utils/cache/relcache.c ./backend/utils/cache/relcache.c
*** ../src.orig/backend/utils/cache/relcache.c	Sat Jun  2 11:17:49 2001
--- ./backend/utils/cache/relcache.c	Sat Jun  2 11:18:33 2001
***************
*** 2263,2269 ****
  				break;
  
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(adrel, SnapshotNow, &tuple, &buffer);
  			pfree(indexRes);
  			if (tuple.t_data == NULL)
  				continue;
--- 2263,2269 ----
  				break;
  
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(adrel, SnapshotNow, &tuple, &buffer, sd);
  			pfree(indexRes);
  			if (tuple.t_data == NULL)
  				continue;
***************
*** 2370,2376 ****
  				break;
  
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(rcrel, SnapshotNow, &tuple, &buffer);
  			pfree(indexRes);
  			if (tuple.t_data == NULL)
  				continue;
--- 2370,2376 ----
  				break;
  
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(rcrel, SnapshotNow, &tuple, &buffer, sd);
  			pfree(indexRes);
  			if (tuple.t_data == NULL)
  				continue;
***************
*** 2508,2514 ****
  			tuple.t_self = indexRes->heap_iptr;
  			tuple.t_datamcxt = NULL;
  			tuple.t_data = NULL;
! 			heap_fetch(indrel, SnapshotNow, &tuple, &buffer);
  			pfree(indexRes);
  			if (tuple.t_data == NULL)
  				continue;
--- 2508,2514 ----
  			tuple.t_self = indexRes->heap_iptr;
  			tuple.t_datamcxt = NULL;
  			tuple.t_data = NULL;
! 			heap_fetch(indrel, SnapshotNow, &tuple, &buffer, sd);
  			pfree(indexRes);
  			if (tuple.t_data == NULL)
  				continue;
diff -crN ../src.orig/backend/utils/hash/dynahash.c ./backend/utils/hash/dynahash.c
*** ../src.orig/backend/utils/hash/dynahash.c	Sat Jun  2 11:17:49 2001
--- ./backend/utils/hash/dynahash.c	Sat Jun  2 11:18:33 2001
***************
*** 82,99 ****
   * ----------------
   */
  static MemoryContext DynaHashCxt = NULL;
  
  static void *
  DynaHashAlloc(Size size)
  {
! 	if (!DynaHashCxt)
! 		DynaHashCxt = AllocSetContextCreate(TopMemoryContext,
! 											"DynaHash",
! 											ALLOCSET_DEFAULT_MINSIZE,
! 											ALLOCSET_DEFAULT_INITSIZE,
! 											ALLOCSET_DEFAULT_MAXSIZE);
! 
! 	return MemoryContextAlloc(DynaHashCxt, size);
  }
  
  #define MEM_ALLOC		DynaHashAlloc
--- 82,94 ----
   * ----------------
   */
  static MemoryContext DynaHashCxt = NULL;
+ static MemoryContext CurrentDynaHashCxt = NULL;
  
  static void *
  DynaHashAlloc(Size size)
  {
! 	Assert(MemoryContextIsValid(CurrentDynaHashCxt));
! 	return MemoryContextAlloc(CurrentDynaHashCxt, size);
  }
  
  #define MEM_ALLOC		DynaHashAlloc
***************
*** 133,138 ****
--- 128,144 ----
  	HHDR	   *hctl;
  	HTAB	   *hashp;
  
+ 	if (!DynaHashCxt)
+ 		DynaHashCxt = AllocSetContextCreate(TopMemoryContext,
+ 											"DynaHash",
+ 											ALLOCSET_DEFAULT_MINSIZE,
+ 											ALLOCSET_DEFAULT_INITSIZE,
+ 											ALLOCSET_DEFAULT_MAXSIZE);
+ 
+ 	if (flags & HASH_CONTEXT)
+ 		CurrentDynaHashCxt = info->hcxt;
+ 	else
+ 		CurrentDynaHashCxt = DynaHashCxt;
  
  	hashp = (HTAB *) MEM_ALLOC(sizeof(HTAB));
  	MemSet(hashp, 0, sizeof(HTAB));
***************
*** 157,162 ****
--- 163,169 ----
  		hashp->segbase = (char *) info->segbase;
  		hashp->alloc = info->alloc;
  		hashp->dir = (SEG_OFFSET *) info->dir;
+ 		hashp->hcxt = NULL;
  
  		/* hash table already exists, we're just attaching to it */
  		if (flags & HASH_ATTACH)
***************
*** 171,182 ****
  		hashp->alloc = MEM_ALLOC;
  		hashp->dir = NULL;
  		hashp->segbase = NULL;
  
  	}
  
  	if (!hashp->hctl)
  	{
! 		hashp->hctl = (HHDR *) hashp->alloc(sizeof(HHDR));
  		if (!hashp->hctl)
  			return 0;
  	}
--- 178,190 ----
  		hashp->alloc = MEM_ALLOC;
  		hashp->dir = NULL;
  		hashp->segbase = NULL;
+ 		hashp->hcxt = DynaHashCxt;
  
  	}
  
  	if (!hashp->hctl)
  	{
! 			hashp->hctl = (HHDR *) hashp->alloc(sizeof(HHDR));
  		if (!hashp->hctl)
  			return 0;
  	}
***************
*** 218,223 ****
--- 226,253 ----
  	}
  	if (flags & HASH_ALLOC)
  		hashp->alloc = info->alloc;
+ 	else
+ 	{
+ 		if (flags & HASH_CONTEXT)
+ 		{
+ 			CurrentDynaHashCxt = AllocSetContextCreate(info->hcxt,
+ 											"DynaHashTable",
+ 											ALLOCSET_DEFAULT_MINSIZE,
+ 											ALLOCSET_DEFAULT_INITSIZE,
+ 											ALLOCSET_DEFAULT_MAXSIZE);
+ 			
+ 			hashp->hcxt = CurrentDynaHashCxt;
+ 		}
+ 		else
+ 		{
+ 			CurrentDynaHashCxt = AllocSetContextCreate(DynaHashCxt,
+ 											"DynaHashTable",
+ 											ALLOCSET_DEFAULT_MINSIZE,
+ 											ALLOCSET_DEFAULT_INITSIZE,
+ 											ALLOCSET_DEFAULT_MAXSIZE);
+ 			hashp->hcxt = CurrentDynaHashCxt;
+ 		}
+ 	}
  
  	if (init_htab(hashp, nelem))
  	{
***************
*** 305,310 ****
--- 335,341 ----
  	/* Allocate a directory */
  	if (!(hashp->dir))
  	{
+ 		CurrentDynaHashCxt = hashp->hcxt;
  		hashp->dir = (SEG_OFFSET *)
  			hashp->alloc(hctl->dsize * sizeof(SEG_OFFSET));
  		if (!hashp->dir)
***************
*** 414,419 ****
--- 445,458 ----
   * allocated individually, see bucket_alloc!!  Why doesn't it crash?
   * ANSWER: it probably does crash, but is never invoked in normal
   * operations...
+  *
+  * Thomas is right, it does crash. Therefore I changed the code
+  * to use a separate memory context which is a child of the DynaHashCxt
+  * by default. And the HASHCTL structure got extended with a hcxt
+  * field, where someone can specify an explicit context (giving new
+  * flag HASH_CONTEXT) and forget about hash_destroy() completely.
+  * The shmem operations aren't changed, but in shmem mode a destroy
+  * doesn't work anyway. Jan Wieck 03/2001.
   */
  
  void
***************
*** 421,426 ****
--- 460,466 ----
  {
  	if (hashp != NULL)
  	{
+ #if 0
  		SEG_OFFSET	segNum;
  		SEGMENT		segp;
  		int			nsegs = hashp->hctl->nsegs;
***************
*** 429,442 ****
--- 469,495 ----
  					p,
  					q;
  		ELEMENT    *curr;
+ #endif
  
  		/* cannot destroy a shared memory hash table */
  		Assert(!hashp->segbase);
  		/* allocation method must be one we know how to free, too */
  		Assert(hashp->alloc == MEM_ALLOC);
+ 		/* so this hashtable must have it's own context */
+ 		Assert(hashp->hcxt != NULL);
  
  		hash_stats("destroy", hashp);
  
+ 		/*
+ 		 * Free buckets, dir etc. by destroying the hash tables
+ 		 * memory context.
+ 		 */
+ 		MemoryContextDelete(hashp->hcxt);
+ 
+ #if 0
+ 		/*
+ 		 * Dead code - replaced by MemoryContextDelete() above
+ 		 */
  		for (segNum = 0; nsegs > 0; nsegs--, segNum++)
  		{
  
***************
*** 453,458 ****
--- 506,518 ----
  			MEM_FREE((char *) segp);
  		}
  		MEM_FREE((char *) hashp->dir);
+ #endif
+ 
+ 		/*
+ 		 * Free the HTAB and control structure, which are allocated
+ 		 * in the parent context (DynaHashCxt or the context given
+ 		 * by the caller of hash_create().
+ 		 */
  		MEM_FREE((char *) hashp->hctl);
  		MEM_FREE((char *) hashp);
  	}
***************
*** 876,881 ****
--- 936,942 ----
  	old_dirsize = hashp->hctl->dsize * sizeof(SEG_OFFSET);
  	new_dirsize = new_dsize * sizeof(SEG_OFFSET);
  
+ 	CurrentDynaHashCxt = hashp->hcxt;
  	old_p = (char *) hashp->dir;
  	p = (char *) hashp->alloc((Size) new_dirsize);
  
***************
*** 898,903 ****
--- 959,965 ----
  	SEGMENT		segp;
  	SEG_OFFSET	segOffset;
  
+ 	CurrentDynaHashCxt = hashp->hcxt;
  	segp = (SEGMENT) hashp->alloc(sizeof(BUCKET_INDEX) * hashp->hctl->ssize);
  
  	if (!segp)
***************
*** 928,933 ****
--- 990,996 ----
  	/* make sure its aligned correctly */
  	bucketSize = MAXALIGN(bucketSize);
  
+ 	CurrentDynaHashCxt = hashp->hcxt;
  	tmpBucket = (ELEMENT *) hashp->alloc(BUCKET_ALLOC_INCR * bucketSize);
  
  	if (!tmpBucket)
